package core.repositories.timemanager;

import core.entities.User;
import core.entities.timemanager.Taskgroup;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import javax.transaction.Transactional;
import java.util.List;

@Repository
public interface TaskgroupRepository extends CrudRepository<Taskgroup, Long> {

    @Query("SELECT tg FROM Taskgroup tg WHERE tg.user.username = ?1")
    List<Taskgroup> findAllByUser(String username);

    @Query("SELECT tg FROM Taskgroup tg WHERE tg.user.username = ?1 AND tg.parent IS NULL")
    List<Taskgroup> findAllTopTaskgroupsByUser(String username);

    @Modifying
    @Transactional
    void deleteAllByUser(User user);
}
